
;keinplan file i/o and graphics

;****************************************

;equates

MODE03  EQU 3
MODE13  EQU 13h
VGASEG  EQU 0A000h

;****************************************

;code segment
;for .COM programs, all code and data must fit into 64 Kb
;so, only one segment is typically used

CODE_SEG SEGMENT

        ASSUME  CS:CODE_SEG, DS:CODE_SEG

;****************************************

        ORG     100h

INIT_PROGRAMM PROC NEAR

;----------------------------------------

;set the DS register
;this is not required in .COM programs
;but it is if the file is executed in .EXE form

        PUSH    CS
        POP     DS

;----------------------------------------

;set video mode 13h

        MOV     AX,MODE13
        INT     10h

;----------------------------------------

;create file

        MOV     DX,OFFSET FILENAME
        MOV     FILENAME_ADDRESS,DX
        CALL    CREATE_FILE             ;create file
        JC      FILE_ERROR_EXIT2

        MOV     FILE_HANDLE,AX

;----------------------------------------

;write file

        MOV     BX,AX                   ;handle in BX
        MOV     DX,OFFSET WRITEBUFFER
        MOV     CX,192
        CALL    WRITE_FILE              ;write file
        CALL    CLOSE_FILE              ;close file
        JC      FILE_ERROR_EXIT2

;----------------------------------------

;open file
;FILENAME_ADDRESS value is already set

        MOV     DX,OFFSET FILENAME
        MOV     AL,0                    ;read mode
        CALL    OPEN_FILE               ;open file
        JC      FILE_ERROR_EXIT2

        MOV     FILE_HANDLE,AX

;----------------------------------------

;read file

        MOV     BX,AX                   ;handle in BX
        MOV     DX,OFFSET READBUFFER
        MOV     CX,192
        CALL    READ_FILE               ;read file
        CALL    CLOSE_FILE              ;close file
        JNC     VIDEO_WRITE

        JMP SHORT FILE_ERROR_EXIT2

;----------------------------------------

;context variable error report

FILE_ERROR_EXIT1:
        CALL    CLOSE_FILE              ;close file

FILE_ERROR_EXIT2:
        PUSH    AX                      ;save error code
        MOV     AX,MODE03
        INT     10h
        MOV     DX,OFFSET ERROR_STRING
        MOV     AH,9
        INT     21h
        MOV     DX,ERROR_TYPE
        MOV     AH,9
        INT     21h
        MOV     DX,OFFSET ERROR_FILE
        MOV     AH,9
        INT     21h
        MOV     DX,FILENAME_ADDRESS
        MOV     AH,9
        INT     21h
        POP     AX                      ;recall error code
        JMP     ERROR_EXIT

;----------------------------------------

;write stuff to video ram

VIDEO_WRITE:
        CLD
        MOV     AX,VGASEG
        MOV     ES,AX
        MOV     DI,30232
        MOV     SI,OFFSET READBUFFER
        MOV     DX,12

COPY_GRAPHIC:
        MOV     CX,16
        REP     MOVSB
        ADD     DI,304
        DEC     DX
        JNZ     COPY_GRAPHIC

;wait for a keypress

        MOV     AH,0
        INT     16h

;set video mode 3

        MOV     AX,MODE03
        INT     10h

;----------------------------------------

;no error - set return code = 0

NORMAL_EXIT:
        MOV     AL,0

;end program

ERROR_EXIT:
        MOV     AH,4Ch
        INT     21h

INIT_PROGRAMM ENDP

;****************************************

CREATE_FILE PROC NEAR

        XOR     CX,CX
        MOV     AH,3Ch                  ;create file
        INT     21h
        MOV WORD PTR ERROR_TYPE,OFFSET ERROR_CREATE
        RET

CREATE_FILE ENDP

;****************************************

OPEN_FILE PROC NEAR

        MOV     AH,3Dh                  ;open file
        INT     21h
        MOV WORD PTR ERROR_TYPE,OFFSET ERROR_OPEN
        RET

OPEN_FILE ENDP

;****************************************

CLOSE_FILE PROC NEAR

        PUSHF
        PUSH    AX
        MOV     AH,3Eh                  ;close file
        INT     21h
        POP     AX
        POPF
        RET

CLOSE_FILE ENDP

;****************************************

WRITE_FILE PROC NEAR

        MOV     AH,40h                  ;write file
        INT     21h
        MOV WORD PTR ERROR_TYPE,OFFSET ERROR_WRITE
        RET

WRITE_FILE ENDP

;****************************************

READ_FILE PROC NEAR

        MOV     AH,3Fh                  ;read file
        INT     21h
        MOV WORD PTR ERROR_TYPE,OFFSET ERROR_READ
        RET

READ_FILE ENDP

;****************************************

;data area

FILENAME_ADDRESS DW ?
FILE_HANDLE      DW ?
ERROR_TYPE       DW ?

FILENAME         DB 'pac.img',0,0Dh,0Ah,24h

ERROR_STRING     DB 'Error ',24h
ERROR_CREATE     DB 'Creat',24h
ERROR_OPEN       DB 'Open',24h
ERROR_READ       DB 'Read',24h
ERROR_WRITE      DB 'Writ',24h
ERROR_FILE       DB 'ing File: ',24h

WRITEBUFFER      DB 15,15,15,15,42,42,42,42,42,42,42,42,15,15,15,15
                 DB 15,15,42,42,42,42,42,42,42,42,42,42,42,42,15,15
                 DB 42,42,42,42,42,42,42,15,15,42,42,42,42,42,42,15
                 DB 15,15,42,42,42,42,42,42,42,42,42,42,42,42,42,42
                 DB 15,15,15,15,15,42,42,42,42,42,42,42,42,42,42,42
                 DB 15,15,15,15,15,15,15,42,42,42,42,42,42,42,42,42
                 DB 15,15,15,15,15,15,15,15,15,42,42,42,42,42,42,42
                 DB 15,15,15,15,15,15,15,15,15,42,42,42,42,42,42,42
                 DB 15,15,15,15,15,15,42,42,42,42,42,42,42,42,42,42
                 DB 42,42,42,42,42,42,42,42,42,42,42,42,42,42,42,15
                 DB 15,15,42,42,42,42,42,42,42,42,42,42,42,42,15,15
                 DB 15,15,15,15,42,42,42,42,42,42,42,42,15,15,15,15

READBUFFER       LABEL BYTE

CODE_SEG ENDS

        END     INIT_PROGRAMM

